﻿using UnityEngine;
using Steamworks;
using HarmonyLib;

public class MyFirstProject : Mod
{
    static MyFirstProject myClass;
    int multiplier = 1;

    [ConsoleCommand(name: "fishingMultiplier", docs: "changes the multiplier for fishing")]
    public static void fishingMultiplierMethod(string[] arg)
    {
        int x = int.Parse(arg[0]);
        myClass.multiplier = x;
    }

    int areBaitsInfinite = 0;
    [ConsoleCommand(name: "infinitebaits", docs: "1: infinite baits, 0: finite baits")]
    public static void infiniteBaits(string[] arg)
    {
        int x = int.Parse(arg[0]);
        myClass.areBaitsInfinite = x;
    }

    int isRodUnbreakable = 0;
    [ConsoleCommand(name: "unbreakablerod", docs: "1: unbreakable rod, 2: breakable rod")]
    public static void unbreakableRod(string[] arg)
    {
        int x = int.Parse(arg[0]);
        myClass.isRodUnbreakable = x;
    }

    int oxygenBarOption = 0;
    [ConsoleCommand(name: "infiniteoxygen", docs: "0: finite oxygen, 1: infinite oxygen, 2: infinite oxygen + remove oxygen bar")]
    public static void infiniteOxygen(string[] arg)
    {
        int x = int.Parse(arg[0]);
        if(x!=0 && x!=1 && x!=2)
        {
            x = 0;
        }
        myClass.oxygenBarOption = x;
    }

    [HarmonyPatch(typeof(Stat_Oxygen), "Update")]
    public class oxygenPatch
    {
        [HarmonyPostfix]
        static void oxygen(Stat_Oxygen __instance)
        {
            if(myClass.oxygenBarOption == 1)
            {
                __instance.Value = __instance.Max - 0.01f;
            }
            if(myClass.oxygenBarOption == 2)
            {
                __instance.Value = __instance.Max;
            }
        }
    }

    int sprinklerOption = 0;
    [ConsoleCommand(name: "sprinklercheat", docs: "0: sprinkler requires water and electricty, 1: requires nothing, 2: requires water, 3: requires electricity")]
    public static void sprinklerCheat(string[] arg)
    {
        int x = int.Parse(arg[0]);
        if(x!=0 && x!=1 && x!=2 && x != 3)
        {
            x = 0;
        }
        myClass.sprinklerOption = x;
    }

    [HarmonyPatch(typeof(Sprinkler), "CanWater", MethodType.Getter)]
    public class sprinklerPatch
    {
        static bool Prefix(Sprinkler __instance, ref bool __result)
        {

            switch(myClass.sprinklerOption)
            {
                case 0:
                    return true;
                    break;
                case 1:
                    __result = true;
                    break;
                case 2:
                    __result = __instance.waterTank.CurrentTankAmount > 0f;
                    break;
                case 3:
                    __result =__instance.battery.CanGiveElectricity;
                    break;
            }
            
            return false;
        }
    }

    int weakSharkOption = 0;
    [ConsoleCommand(name: "weakshark", docs: "1: shark doesnt do any damage to a player, 0: shark does damage to a player")]
    public static void weakShark(string[] arg)
    {
        int x = int.Parse(arg[0]);
        if(x!=0 && x!=1)
        {
            x = 0;
        }

        if (x == 1) { myClass.weakSharkOption = 0; }
        if (x==0) { myClass.weakSharkOption = 1; }


        GameModeValueManager.GetCurrentGameModeValue().sharkVariables.damageMultiplier = myClass.weakSharkOption;
    }

    [ConsoleCommand(name: "setsprintspeed", docs: "sets player's sprint speed, default - 5")]
    public static void setsprintSpeed(string[] arg)
    {
        RAPI.GetLocalPlayer().PersonController.sprintSpeed = float.Parse(arg[0]);
    }

    [ConsoleCommand(name: "setswimspeed", docs: "sets player's swim speed, default - 3")]
    public static void setSwimSpeed(string[] arg)
    {
        RAPI.GetLocalPlayer().PersonController.swimSpeed = float.Parse(arg[0]);
    }
    
    [ConsoleCommand(name: "setspeed", docs: "set player's speed, default - 1")]
    public static void setSpeed(string[] arg)
    {
        RAPI.GetLocalPlayer().PersonController.normalSpeed = float.Parse(arg[0]);
    }

    [ConsoleCommand(name: "setgravity", docs: "set player's gravity, default - 20")]
    public static void setGravity(string[] arg)
    {
        RAPI.GetLocalPlayer().PersonController.gravity = float.Parse(arg[0]);
    }

    [ConsoleCommand(name: "setjumpspeed", docs: "set player's jump speed, default - 7")]
    public static void setJumpSpeed(string[] arg)
    {
        RAPI.GetLocalPlayer().PersonController.jumpSpeed = float.Parse(arg[0]);
    }

    int disableHungerOption = 0;
    [ConsoleCommand(name: "disablehunger", docs: "1: disable hunger, 0: enable hunger")]
    public static void disableHunger(string[] arg)
    {
        NourishmentVariables nv = GameModeValueManager.GetCurrentGameModeValue().nourishmentVariables;
        int x = int.Parse(arg[0]);
        if(x!=0 && x!=1)
        {
            x = 0;
        }
        myClass.disableHungerOption = x;

        if(myClass.disableHungerOption == 1)
        {
            nv.foodDecrementRateMultiplier = 0f;
        }
        if(myClass.disableHungerOption == 0)
        {
            nv.foodDecrementRateMultiplier = 1f;
        }
    }

    int disableThirstOption = 0;
    [ConsoleCommand(name: "disablethirst", docs: "1: disable thirst, 0: enable thirst")]
    public static void disableThirst(string[] arg)
    {
        NourishmentVariables nv = GameModeValueManager.GetCurrentGameModeValue().nourishmentVariables;
        int x = int.Parse(arg[0]);
        if (x != 0 && x != 1)
        {
            x = 0;
        }
        myClass.disableThirstOption = x;

        if (myClass.disableThirstOption == 1)
        {
            nv.thirstDecrementRateMultiplier = 0f;
        }
        if (myClass.disableThirstOption == 0)
        {
            nv.thirstDecrementRateMultiplier = 1f;
        }
    }

  

    [HarmonyPatch(typeof(FishingRod), "PullItemsFromSea")]
    public class fishingRodPatch
    {
        [HarmonyPrefix]
        static bool pullItems(FishingRod __instance)
        {
            bool isMetalRod = Traverse.Create(__instance).Field("isMetalRod").GetValue<bool>();
            Rope rope = Traverse.Create(__instance).Field("rope").GetValue<Rope>();
            Network_Player playerNetwork = Traverse.Create(__instance).Field("playerNetwork").GetValue<Network_Player>();
            PlayerAnimator playerAnimator = Traverse.Create(__instance).Field("playerAnimator").GetValue<PlayerAnimator>();
            Throwable throwable = Traverse.Create(__instance).Field("throwable").GetValue<Throwable>();
            FishingBaitHandler fishingBaitHandler = Traverse.Create(__instance).Field("fishingBaitHandler").GetValue<FishingBaitHandler>();
            

            Item_Base randomItemFromCurrentBaitPool = fishingBaitHandler.GetRandomItemFromCurrentBaitPool(isMetalRod);
            randomItemFromCurrentBaitPool = fishingBaitHandler.GetRandomItemFromCurrentBaitPool(isMetalRod);


            if (randomItemFromCurrentBaitPool != null)
            {
                playerNetwork.Inventory.AddItem(randomItemFromCurrentBaitPool.UniqueName, myClass.multiplier);
                if (myClass.areBaitsInfinite != 1)
                {
                    fishingBaitHandler.ConsumeBait();
                }
            }
            playerAnimator.SetAnimation(PlayerAnimation.Trigger_FishingRetract, false);
            __instance.rodAnimator.SetTrigger("FishingRetract");
            ParticleManager.PlaySystem("WaterSplash_Hook", throwable.throwableObject.position + Vector3.up * 0.1f, true);
            Traverse.Create(__instance).Method("ResetRod").GetValue();

            if(myClass.isRodUnbreakable == 0)
            {
                if (playerNetwork.Inventory.RemoveDurabillityFromHotSlot(1))
                {
                    rope.gameObject.SetActive(false);
                }
            }
            else
            {
                rope.gameObject.SetActive(false);
            }

            return false;
        }
    }

    Harmony harmonyInstance;
    public void Start()
    {
        myClass = this;
        harmonyInstance = new Harmony("com.Wydra.doorPatch");
        harmonyInstance.PatchAll();
    }

    public void OnModUnload()
    {
        harmonyInstance.UnpatchAll(harmonyInstance.Id);
        Debug.Log("Mod MyFirstProject has been unloaded!");
    }


    int safeRaftOption = 0;
    [ConsoleCommand(name: "saferaft", docs: "1: shark won't attack your raft, 0: will attack")]
    public static void safeRaft(string[] arg)
    {
        int x = int.Parse(arg[0]);
        if(x!=0 && x != 1)
        {
            x = 0;
        }
        myClass.safeRaftOption = x;
    }

    [HarmonyPatch(typeof(AI_State_Attack_Block_Shark), "FindBlockToAttack")]
    public static class raftAttackPatch
    {
        private static void Postfix(ref Block __result)
        {
            if (myClass.safeRaftOption == 1)
            {
                __result = null;
            }
        }
    }

    float customPullSpeed = 3f;
    [ConsoleCommand(name: "sethookpullspeed", docs: "set hook's pulling speed, default - 3")]
    public static void getHookObjects(string[] arg)
    {
        myClass.customPullSpeed = float.Parse(arg[0]);
    }

    [HarmonyPatch(typeof(Hook), "OnSelect")]
    public class hookAwakePatch
    {
        private static void Postfix(Hook __instance)
        {
            __instance.pullSpeed = myClass.customPullSpeed;
        }
    }

    [HarmonyPatch(typeof(Hook), "OnDeSelect")]
    public class hookAwakePatch2
    {
        private static void Postfix(Hook __instance)
        {
            __instance.pullSpeed = 3f;
        }
    }

}